function datestr8601_test()
%
% (c) 2011-2020 Stephen Cobeldick
%
%fun = @(k,dvb,dve)datevec(k*datenum(dve)+(1-k)*datenum(dvb));
%
tmp = {'%s %3d','<a href="matlab:opentoline(''%1$s.m'',%2$3d)">%1$s %2$3d</a>'};
chk(tmp{1+feature('hotlinks')}) % reset counter
%
clock = [1999,1,3,15,6,48.0568];
now = datenum(clock);
dtm = datetime(clock);
%
%% Examples Mfile Help
%
chk('19990103T150648', now)
chk('1999003_1506', now,'yn_HM')
chk('1999-01-03T15:06:48', clock,'*ymdHMS')
chk({'5','Fri'},now-2,'D','DDD')
chk('Sunday 3rd January 1999', dtm,'DDDD','d*','mmmm','yyyy')
chk({'3rd','1998-W53-7','January 1999'}, now,'d*','*YWD','mmmm','yyyy');
%
%% Examples Timestamp Tables
%
chk('19990103T150648',     now, 'ymdHMS')
chk('1999-01-03T15:06:48', now,'*ymdHMS')
chk('1999003T150648',      now,  'ynHMS')
chk('1999-003T15:06:48',   now, '*ynHMS')
chk('1998W537T150648',     now, 'YWDHMS')
chk('1998-W53-7T15:06:48', now,'*YWDHMS')
% Reduced precision:
chk('7T150648',             now,  'DHMS')
chk('7T15:06:48',           now, '*DHMS')
chk('0103T15',             now,  'mdH')
chk('01-03T15',            now, '*mdH')
% Separator character:
chk('003_150648',          now,  'n_HMS')
chk('003_15:06:48',        now, '*n_HMS')
chk('1998W537@15',       now,  'YWD@H')
chk('1998-W53-7@15',     now, '*YWD@H')
% Decimal fraction:
chk('150648.0568',           now,  'HMS4')
chk('15:06:48.0568',         now, '*HMS4')
chk('1998W53.9471032',   now,  'YW7') % fun(0.94710326851678217,[1998,12,28],[1999,1,4])
chk('1998-W53.9471032',  now, '*YW7') % fun(0.94710326851678217,[1998,12,28],[1999,1,4])
chk('1999.0072047202',   now,  'y10') % fun(0.0072047202181300682,[1999,1,1],[2000,1,1])
chk('1999.0072047202',   now, '*y10') % fun(0.0072047202181300682,[1999,1,1],[2000,1,1])
%
%% Examples Single Value Table
%
%%% Calendar year
chk('1999',   now, 'yyyy')
chk('3',      now, 'n')
chk('3rd',    now, 'n*')
chk('003',    now, 'nnn')
chk('362',    now, 'r')
chk('362nd',  now, 'r*')
chk('362',    now, 'rrr')
chk('1',      now, 'q')
chk('1st',    now, 'q*')
chk('Q1',     now, 'qq')
chk('First',  now, 'qqqq')
chk('1',      now, 'm')
chk('1st',    now, 'm*')
chk('01',     now, 'mm')
chk('Jan',    now, 'mmm')
chk('January',now, 'mmmm')
chk('3',      now, 'd')
chk('3rd',    now, 'd*')
chk('03',     now, 'dd')
%%% Week-numbering year
chk('1998',   now, 'YYYY')
chk('371',    now, 'N')
chk('371st',  now, 'N*')
chk('371',    now, 'NNN')
chk('0',      now, 'R')
chk('0th',    now, 'R*')
chk('000',    now, 'RRR')
chk('4',      now, 'Q')
chk('4th',    now, 'Q*')
chk('Q4',     now, 'QQ')
chk('Fourth', now, 'QQQQ')
chk('53',     now, 'W')
chk('53rd',   now, 'W*')
chk('53',     now, 'WW')
chk('0',      now, 'X')
chk('0th',    now, 'X*')
chk('00',     now, 'XX')
%%% Weekday
chk('7',      now, 'D')
chk('7th',    now, 'D*')
chk('Su',     now, 'DD')
chk('Sun',    now, 'DDD')
chk('Sunday', now, 'DDDD')
%%% Time of day
chk('15',     now, 'H')
chk('15',     now, 'HH')
chk('6',      now, 'M')
chk('06',     now, 'MM')
chk('48',     now, 'S')
chk('48',     now, 'SS')
chk('0',      now, 'F')
chk('05',     now, 'FF')
chk('056',    now, 'FFF')
%%% AM/PM
chk('Post-Meridian', now, 'MAMP')
%
%% Check Calender Year
%
chk('2012-12-31T23:59:59.000 2012 12 31', [2012,12,31,23,59,59.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-04-04T05:02:02.170 2012 04 04', [2012, 4, 4, 5, 2, 2.170], '*ymdHMS3','yyyy','mm','dd')
chk('2012-02-29T12:00:00.000 2012 02 29', [2012, 2,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2011-03-01T12:00:00.000 2011 03 01', [2011, 3, 1,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2034-03-01T00:00:00.000 2034 03 01', [2034, 3, 1, 0, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2034-02-27T23:59:59.999 2034 02 27', [2034, 2,27,23,59,59.999], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
chk('2012-01-29T12:00:00.000 2012 01 29', [2012, 1,29,12, 0, 0.000], '*ymdHMS3','yyyy','mm','dd')
%
%% Check Week-Numbering Year
%
chk('2004-W53-6T00:00:00.000 2004 53 6', [2005, 1, 1, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2004-W53-7T00:00:00.000 2004 53 7', [2005, 1, 2, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2005-W52-6T00:00:00.000 2005 52 6', [2005,12,31, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2007-W01-1T00:00:00.000 2007 01 1', [2007, 1, 1, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2007-W52-7T00:00:00.000 2007 52 7', [2007,12,30, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2008-W01-1T00:00:00.000 2008 01 1', [2007,12,31, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2008-W01-2T00:00:00.000 2008 01 2', [2008, 1, 1, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2008-W52-7T00:00:00.000 2008 52 7', [2008,12,28, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W01-1T00:00:00.000 2009 01 1', [2008,12,29, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W01-2T00:00:00.000 2009 01 2', [2008,12,30, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W01-3T00:00:00.000 2009 01 3', [2008,12,31, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W01-4T00:00:00.000 2009 01 4', [2009, 1, 1, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W53-4T00:00:00.000 2009 53 4', [2009,12,31, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W53-5T00:00:00.000 2009 53 5', [2010, 1, 1, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W53-6T00:00:00.000 2009 53 6', [2010, 1, 2, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
chk('2009-W53-7T00:00:00.000 2009 53 7', [2010, 1, 3, 0, 0, 0.000], '*YWDHMS3','YYYY','WW','D')
%
%% Check Trailing Fraction
%
chk('2000-060T00:00:00.900', [2000, 2,29, 0, 0, 0.9], '*ynHMS3')
chk('2000-060T00:00.8000',   [2000, 2,29, 0, 0.8, 0], '*ynHM4')
chk('2000-060T00.70000',     [2000, 2,29, 0.7, 0, 0], '*ynH5')
chk('2000-060.600000',       [2000, 2,29.6, 0, 0, 0], '*yn6')
chk('2000-02-29T00:00:00.900', [2000, 2,29, 0, 0, 0.9], '*ymdHMS3')
chk('2000-02-29T00:00.8000',   [2000, 2,29, 0, 0.8, 0], '*ymdHM4')
chk('2000-02-29T00.70000',     [2000, 2,29, 0.7, 0, 0], '*ymdH5')
chk('2000-02-29.600000',       [2000, 2,29.6, 0, 0, 0], '*ymd6')
chk('2000-02.5000000',         [2000, 2,15,  12, 0, 0], '*ym7') % fun(0.5,[2000,02,01],[2000,03,01])
chk('2000.40000000',           [2000, 5,26,   9,36, 0], '*y8')  % fun(0.4,[2000,01,01],[2001,01,01])
chk('2000-W09-2T00:00:00.900', [2000, 2,29, 0, 0, 0.9], '*YWDHMS3')
chk('2000-W09-2T00:00.8000',   [2000, 2,29, 0, 0.8, 0], '*YWDHM4')
chk('2000-W09-2T00.70000',     [2000, 2,29, 0.7, 0, 0], '*YWDH5')
chk('2000-W09-2.600000',       [2000, 2,29.6, 0, 0, 0], '*YWD6')
chk('2000-W09.5000000',        [2000, 3, 2,  12, 0, 0], '*YW7') % fun(0.5,[2000,02,28],[2000,03,06])
chk('2000.40000000',           [2000, 5,27,  14,24, 0], '*Y8')  % fun(0.4,[2000,01,03],[2001,01,01])
%
%% Check AM/PM
%
chk(     'Midnight', [2012,12,31, 0,0,0], 'MAMP')
chk('Ante-Meridian', [2012,12,31, 6,0,0], 'MAMP')
chk(       'Midday', [2012,12,31,12,0,0], 'MAMP')
chk('Post-Meridian', [2012,12,31,18,0,0], 'MAMP')
chk(     'Midnight', [2012,12,31,24,0,0], 'MAMP')
chk(     'Midnight', [1987,04,23, 0,0,0], 'MAMP')
chk('Ante-Meridian', [1987,04,23, 6,0,0], 'MAMP')
chk(       'Midday', [1987,04,23,12,0,0], 'MAMP')
chk('Post-Meridian', [1987,04,23,18,0,0], 'MAMP')
chk(     'Midnight', [1987,04,23,24,0,0], 'MAMP')
%
%% Check Quarter and Year
%
% Calendar:
chk({'1','1998'}, [1998,01,01], 'q','y')
chk({'1','1998'}, [1998,03,31], 'q','y')
chk({'2','1998'}, [1998,04,01], 'q','y')
chk({'2','1998'}, [1998,06,30], 'q','y')
chk({'3','1998'}, [1998,07,01], 'q','y')
chk({'3','1998'}, [1998,09,30], 'q','y')
chk({'4','1998'}, [1998,10,01], 'q','y')
chk({'4','1998'}, [1998,12,31], 'q','y')
chk({'1','1999'}, [1999,01,01], 'q','y')
chk({'1','1999'}, [1999,03,31], 'q','y')
chk({'2','1999'}, [1999,04,01], 'q','y')
chk({'2','1999'}, [1999,06,30], 'q','y')
chk({'3','1999'}, [1999,07,01], 'q','y')
chk({'3','1999'}, [1999,09,30], 'q','y')
chk({'4','1999'}, [1999,10,01], 'q','y')
chk({'4','1999'}, [1999,12,31], 'q','y')
chk({'1','2000'}, [2000,01,01], 'q','y')
chk({'1','2000'}, [2000,03,31], 'q','y')
chk({'2','2000'}, [2000,04,01], 'q','y')
chk({'2','2000'}, [2000,06,30], 'q','y')
chk({'3','2000'}, [2000,07,01], 'q','y')
chk({'3','2000'}, [2000,09,30], 'q','y')
chk({'4','2000'}, [2000,10,01], 'q','y')
chk({'4','2000'}, [2000,12,31], 'q','y')
chk({'1','2001'}, [2001,01,01], 'q','y')
chk({'1','2001'}, [2001,03,31], 'q','y')
chk({'2','2001'}, [2001,04,01], 'q','y')
chk({'2','2001'}, [2001,06,30], 'q','y')
chk({'3','2001'}, [2001,07,01], 'q','y')
chk({'3','2001'}, [2001,09,30], 'q','y')
chk({'4','2001'}, [2001,10,01], 'q','y')
chk({'4','2001'}, [2001,12,31], 'q','y')
% Week-numbering:
chk({'1','1998', '1'}, [1997,12,29], 'Q','Y','W')
chk({'1','1998','13'}, [1998,03,29], 'Q','Y','W')
chk({'2','1998','14'}, [1998,03,30], 'Q','Y','W')
chk({'2','1998','26'}, [1998,06,28], 'Q','Y','W')
chk({'3','1998','27'}, [1998,06,29], 'Q','Y','W')
chk({'3','1998','39'}, [1998,09,27], 'Q','Y','W')
chk({'4','1998','40'}, [1998,09,28], 'Q','Y','W')
chk({'4','1998','53'}, [1999,01,03], 'Q','Y','W')
chk({'1','1999', '1'}, [1999,01,04], 'Q','Y','W')
chk({'1','1999','13'}, [1999,04,04], 'Q','Y','W')
chk({'2','1999','14'}, [1999,04,05], 'Q','Y','W')
chk({'2','1999','26'}, [1999,07,04], 'Q','Y','W')
chk({'3','1999','27'}, [1999,07,05], 'Q','Y','W')
chk({'3','1999','39'}, [1999,10,03], 'Q','Y','W')
chk({'4','1999','40'}, [1999,10,04], 'Q','Y','W')
chk({'4','1999','52'}, [2000,01,02], 'Q','Y','W')
chk({'1','2000', '1'}, [2000,01,03], 'Q','Y','W')
chk({'1','2000','13'}, [2000,04,02], 'Q','Y','W')
chk({'2','2000','14'}, [2000,04,03], 'Q','Y','W')
chk({'2','2000','26'}, [2000,07,02], 'Q','Y','W')
chk({'3','2000','27'}, [2000,07,03], 'Q','Y','W')
chk({'3','2000','39'}, [2000,10,01], 'Q','Y','W')
chk({'4','2000','40'}, [2000,10,02], 'Q','Y','W')
chk({'4','2000','52'}, [2000,12,31], 'Q','Y','W')
chk({'1','2001', '1'}, [2001,01,01], 'Q','Y','W')
chk({'1','2001','13'}, [2001,04,01], 'Q','Y','W')
chk({'2','2001','14'}, [2001,04,02], 'Q','Y','W')
chk({'2','2001','26'}, [2001,07,01], 'Q','Y','W')
chk({'3','2001','27'}, [2001,07,02], 'Q','Y','W')
chk({'3','2001','39'}, [2001,09,30], 'Q','Y','W')
chk({'4','2001','40'}, [2001,10,01], 'Q','Y','W')
chk({'4','2001','52'}, [2001,12,30], 'Q','Y','W')
chk({'1','2002', '1'}, [2001,12,31], 'Q','Y','W')
chk({'1','2002', '1'}, [2002,01,01], 'Q','Y','W')
chk({'1','2002', '1'}, [2002,01,02], 'Q','Y','W')
chk({'1','2002', '1'}, [2002,01,03], 'Q','Y','W')
chk({'1','2002', '1'}, [2002,01,04], 'Q','Y','W')
chk({'1','2002', '1'}, [2002,01,05], 'Q','Y','W')
chk({'1','2002', '1'}, [2002,01,06], 'Q','Y','W')
chk({'1','2002', '2'}, [2002,01,07], 'Q','Y','W')
%
%% Check Day of Year
%
chk('1998 52 1 364 7 1998 361 004', now-7, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 365 6 1998 362 003', now-6, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 366 5 1998 363 002', now-5, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 367 4 1998 364 001', now-4, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 368 3 1998 365 000', now-3, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 369 2 1999 001 364', now-2, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 370 1 1999 002 363', now-1, 'Y','W','X','N','R','y','nnn','rrr')
chk('1998 53 0 371 0 1999 003 362', now-0, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 1 363 1999 004 361', now+1, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 2 362 1999 005 360', now+2, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 3 361 1999 006 359', now+3, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 4 360 1999 007 358', now+4, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 5 359 1999 008 357', now+5, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 6 358 1999 009 356', now+6, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 1 51 7 357 1999 010 355', now+7, 'Y','W','X','N','R','y','nnn','rrr')
chk('1999 2 50 8 356 1999 011 354', now+8, 'Y','W','X','N','R','y','nnn','rrr')
%
%% https://en.wikipedia.org/wiki/ISO_8601
%
%%% General principles:
chk('2009-01-06', [2009,01,06], '*ymd')
chk('20090106',   [2009,01,06],  'ymd')
chk('2004-05',    [2004,05,1],  '*ym')
%%% Calendar dates:
chk('1981-04-05', '5 April 1981', '*ymd')
chk('19810405',   '5 April 1981',  'ymd')
%%% Week dates:
chk('2009-W01-1', '29 December 2008', '*YWD')
chk('2009-W53-7', '3 January 2010',   '*YWD')
%%% Ordinal dates:
chk('1981-095',   '1981-04-05', '*yn')
%
%% https://en.wikipedia.org/wiki/ISO_week_date
%
chk({'2005-01-01','2004-W53-6'},  '1 Jan 2005', '*ymd','*YWD')
chk({'2005-01-02','2004-W53-7'},  '2 Jan 2005', '*ymd','*YWD')
chk({'2005-12-31','2005-W52-6'}, '31 Dec 2005', '*ymd','*YWD')
chk({'2006-01-01','2005-W52-7'},  '1 Jan 2006', '*ymd','*YWD')
chk({'2006-01-02','2006-W01-1'},  '2 Jan 2006', '*ymd','*YWD')
chk({'2006-12-31','2006-W52-7'}, '31 Dec 2006', '*ymd','*YWD')
chk({'2007-01-01','2007-W01-1'},  '1 Jan 2007', '*ymd','*YWD')
chk({'2007-12-30','2007-W52-7'}, '30 Dec 2007', '*ymd','*YWD')
chk({'2007-12-31','2008-W01-1'}, '31 Dec 2007', '*ymd','*YWD')
chk({'2008-01-01','2008-W01-2'},  '1 Jan 2008', '*ymd','*YWD')
chk({'2008-12-28','2008-W52-7'}, '28 Dec 2008', '*ymd','*YWD')
chk({'2008-12-29','2009-W01-1'}, '29 Dec 2008', '*ymd','*YWD')
chk({'2008-12-30','2009-W01-2'}, '30 Dec 2008', '*ymd','*YWD')
chk({'2008-12-31','2009-W01-3'}, '31 Dec 2008', '*ymd','*YWD')
chk({'2009-01-01','2009-W01-4'},  '1 Jan 2009', '*ymd','*YWD')
chk({'2009-12-31','2009-W53-4'}, '31 Dec 2009', '*ymd','*YWD')
chk({'2010-01-01','2009-W53-5'},  '1 Jan 2010', '*ymd','*YWD')
chk({'2010-01-02','2009-W53-6'},  '2 Jan 2010', '*ymd','*YWD')
chk({'2010-01-03','2009-W53-7'},  '3 Jan 2010', '*ymd','*YWD')
%
%% https://github.com/uli-weltersbach/ISO-8601-Week-Dates/blob/master/WeekDates.Tests/WeekDateTests.cs
%
chk('2004-W53-7', '2005-01-02', '*YWD')
chk('2005-W52-6', '2005-12-31', '*YWD')
chk('2007-W01-1', '2007-01-01', '*YWD')
chk('2007-W52-7', '2007-12-30', '*YWD')
chk('2008-W01-1', '2007-12-31', '*YWD')
chk('2008-W01-2', '2008-01-01', '*YWD')
chk('2008-W52-7', '2008-12-28', '*YWD')
chk('2009-W01-1', '2008-12-29', '*YWD')
chk('2009-W01-2', '2008-12-30', '*YWD')
chk('2009-W01-3', '2008-12-31', '*YWD')
chk('2009-W01-4', '2009-01-01', '*YWD')
chk('2009-W53-4', '2009-12-31', '*YWD')
chk('2009-W53-5', '2010-01-01', '*YWD')
chk('2009-W53-6', '2010-01-02', '*YWD')
chk('2009-W53-7', '2010-01-03', '*YWD')
chk('2013-W52-6', '2013-12-28', '*YWD')
chk('2013-W52-7', '2013-12-29', '*YWD')
chk('2014-W01-1', '2013-12-30', '*YWD')
chk('2014-W01-2', '2013-12-31', '*YWD')
%
chk()
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%datestr8601_test
function chk(str, varargin)
%
persistent itr cnt fmt fnm
switch nargin
case 0
	fprintf('%s: %d of %d testcases failed.\n',fnm,cnt,itr)
	return
case 1
	itr = 0;
	cnt = 0;
	fmt = str;
	fnm = mfilename();
	return
end
itr = itr+1;
%
if ~iscellstr(str)
	str = {str};
end
%
out = cell(size(str));
try %#ok<TRYNC>
	[out{:}] = datestr8601(varargin{:});
end
%
if ~isequal(out,str)
	cnt = cnt+1;
	db = dbstack();
	s1 = sprintf(', ''%s''',out{:});
	s2 = sprintf(', ''%s''',str{:});
	fprintf(fmt, fnm, db(2).line);
	fprintf('\noutput:%s\nexpect:%s\n', s1(2:end), s2(2:end));
end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%chk